#include <iostream>
#include <cstdint>
#include <algorithm>

#define u16 uint_fast16_t
#define u32 uint_fast32_t
#define u64 uint_fast64_t

using namespace std;


void fastsort (u64 * begin, size_t size) {
    // move last 2 numbers into their correct positions

    if (size < 3) return;

    u64 num1 = *(begin+size-2), num2 = *(begin+size-1);
    u32 idx1 = size-2, idx2 = size-1;

    for (u32 i = 0; i < size; i++) {
        if (begin[i] >= num1) idx1 = i;
        if (begin[i] >= num2) {idx2 = i; break;}
    }

    memcpy(begin+idx1+1, begin+idx1, (size-idx1-2)<<3);
    *(begin+idx1) = num1;

    memcpy(begin+idx2+2, begin+idx2+1, (size-idx1-2)<<3);
    *(begin+idx2+1) = num2;
}


int main () {
    u64 n;
    u32 k;
    std::cin >> n >> k;
    auto vec = new u64[k+1]();
    vec[0] = n;

    // in the beninging
    // in
    // in the
    // in the beninging
    auto beninging = &vec[0];

    for (u32 i = 0; i < k; i++) {
        fastsort(beninging, i+1);
        vec[i+1] = (vec[i]>>1) + (vec[i] & 1);   // divide by 2, ruond up
        vec[i] = vec[i] >> 1;
    }
    fastsort(beninging, k+1);

    u32 q = 0, tmp = 0;
    std::cin >> q;

    for (u32 i = 0; i < q; i++){
        std::cin >> tmp;
        std::cout << vec[k+1-tmp] << " ";
    }
    std::cout << std::endl;

    delete [] vec;

    return 0;

}
