def is_prime(n):
    if n <= 1:
        return False
    for i in range(2, int(n ** 0.5) + 1):
        if n % i == 0:
            return False
    return True

def non_prime_sum(n):
    if n <= 0:
        return []

    primes = [i for i in range(2, n + 1) if is_prime(i)]

    dp = [[] for _ in range(n + 1)]
    dp[0] = [[]]
    for num in range(1, n + 1):
        for prime in primes:
            if prime > num:
                break
            for partition in dp[num - prime]:
                if not partition or partition[-1] <= prime:
                    dp[num].append(partition + [prime])

    return dp[n]

num = int(input())
partitions = non_prime_sum(num)
print(f"Разбиение числа {num} на слагаемые, не содержащие простых чисел:")
for partition in partitions:
    print(partition)