def is_prime(n):
    if n < 2:
        return False
    for i in range(2, int(n ** 0.5) + 1):
        if n % i == 0:
            return False
    return True

def get_partitions(n, k):
    if n == 0:
        yield []
    elif n > 0 and k > 0:
        for i in range(1, n + 1):
            if not is_prime(i):
                for p in get_partitions(n - i, i):
                    yield [i] + p

n = int(input())
for partition in get_partitions(n, n):
    print("+".join(map(str, partition)))

