
#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>

typedef long long LL;

int main( void )
{
  LL n, k;
  int q;

  std::cin >> n;
  std::cin >> k;
  std::cin >> q;


  // Cutting

  std::multiset<LL> Sections = {n};

  for (int i = 0; i < k; i++)
  {
    std::multiset<LL>::iterator MaxSectionIt = Sections.begin();

    // Search max
    for (std::multiset<LL>::iterator s = Sections.begin(); s != Sections.end(); ++s)
      if (*s > *MaxSectionIt)
        MaxSectionIt = s;

    // Cut

    LL Len = *MaxSectionIt;

    Sections.erase(MaxSectionIt);
    if (Len % 2 == 0)
    {
      Sections.emplace(Len / 2);
      Sections.emplace(Len / 2);
    }
    else
    {
      Sections.emplace(Len / 2);
      Sections.emplace(Len / 2 + 1);
    }
  }

  // Sorting
  std::vector<LL> FinalSections(Sections.begin(), Sections.end());
  
  std::sort(FinalSections.begin(), FinalSections.end(), []( LL A, LL B ) -> bool { return A > B; });

  // Answering questions


  for (int i = 0; i < q; i++)
  {
    unsigned qInd;

    std::cin >> qInd;

    if (i > 0)
      std::cout << " ";
    std::cout << FinalSections[qInd - 1];
  }
  return 0;
}

/*
100
5
6
1 2 3 4 5 6
*/