primes = {1: False}

def is_prime(n):
    if n in primes:
        return primes[n]

    i = 2
    while i*i <= n:
        if (n % i) == 0:
            primes[n] = False
            return False
        i += 1

    primes[n] = True
    return True

def gen_non_prime(start, end):
    return [n for n in range(start, end+1) if not is_prime(n)]

def gen_sums(start, end):
    non_prime = gen_non_prime(1, end)
    dp = [[], [[1]]]

    for i in range(2, end+1):
        res = []
        if not is_prime(i):
            res.append([i])
        for val in non_prime:
            if val >= i:
                break
            for arr in dp[i - val]:
                if arr[-1] > val:
                    break
                res.append(arr + [val])
        dp.append(res)

    return dp[start:end+1:]

def gen_sum(n):
    return gen_sums(1, n)[-1]

def main():
    print(*map(lambda arr: '+'.join(map(str, arr)), gen_sum(int(input()))), sep='\n')

if __name__ == '__main__':
    main()
