import heapq


def cut_ropes(n, k, queries):
    ropes = [-n]
    heapq.heapify(ropes)

    for _ in range(k):
        longest_rope = -heapq.heappop(ropes)
        half_length = longest_rope // 2
        remainder = longest_rope % 2

        heapq.heappush(ropes, -half_length)
        heapq.heappush(ropes, -(half_length + remainder))

    result = sorted([-rope for rope in ropes], reverse=True)
    return [result[q - 1] for q in queries]


n = int(input(""))
k = int(input(""))
num_queries = int(input(""))
queries = list(map(int, input("").split()))

result = cut_ropes(n, k, queries)
print(" ".join(map(str, result)))