#include <iostream>
#include <vector>

using namespace std;

bool is_prime(int num) {
    if (num <= 1) {
        return false;
    }
    for (int i = 2; i * i <= num; ++i) {
        if (num % i == 0) {
            return false;
        }
    }
    return true;
}

void generate_partitions(vector<int>& partition, int remaining, int current, int n) {
    if (remaining == 0) {
        for (int i = 0; i < partition.size(); ++i) {
            cout << partition[i];
            if (i != partition.size() - 1) {
                cout << "+";
            }
        }
        cout << endl;
        return;
    }

    for (int i = current; i <= remaining; ++i) {
        if (!is_prime(i)) {
            partition.push_back(i);
            generate_partitions(partition, remaining - i, i, n);
            partition.pop_back();
        }
    }
}

void non_prime_partitions(int n) {
    vector<int> partition;
    generate_partitions(partition, n, 1, n);
}

int main() {
    int n;
    cin >> n;

    non_prime_partitions(n);

    return 0;
}
