def is_prime(num):
    """
    Функция для проверки, является ли число простым.
    """
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True
def non_prime_partitions(n):
    """
    Функция для генерации непростых разбиений числа n.
    """
    dp = [[] for _ in range(n + 1)]

    for i in range(2, n + 1):
        for j in range(2, i):
            if not is_prime(j) and i - j >= 0:
                for partition in dp[i - j]:
                    dp[i].append(partition + [j])
    return dp[n]
n = int(input())
partitions = non_prime_partitions(n)
for partition in partitions:
    print("+".join(map(str, partition)))