def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num ** 0.5) + 1):
        if num % i == 0:
            return False
    return True

def partition(n, max_value):
    if n == 0:
        return [[]]
    elif n < 0:
        return []
    result = []
    for i in range(1, min(max_value, n) + 1):
        if not is_prime(i):
            sub_partitions = partition(n - i, i)
            for sub_partition in sub_partitions:
                result.append([i] + sub_partition)
    return result

# Пример использования функции
number = 5
partitions = partition(number, number)
non_prime_partitions = [p for p in partitions if not any(is_prime(x) for x in p)]
print(f"Непростые разбиения числа {number} на слагаемые: {non_prime_partitions}")
