def factorize(n):
    factors = {}
    while n % 2 == 0:
        factors[2] = factors.get(2, 0) + 1
        n //= 2
    i = 3
    while i * i <= n:
        while n % i == 0:
            factors[i] = factors.get(i, 0) + 1
            n //= i
        i += 2

    if n > 2:
        factors[n] = factors.get(n, 0) + 1

    return factors


def count_nontrivial_divisors(n):
    factors = factorize(n)
    if len(factors) == 2 and all(v == list(factors.values())[0] for v in factors.values()):
        return 1
    else:
        return 0


n = int(input())
print(count_nontrivial_divisors(n))
