#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

long long dist(vector<int> arr, size_t from, size_t to) {
    long long res = 0;

    for(size_t i = from; i <= to; i++) {
        res += arr[i];
    }
    return res;
}

size_t searchd(vector<long long> arr, long long el) {
    size_t i = 0;
    size_t iMax = arr.size();
    while(arr[i] < el && i < iMax) {
        i++;
    }
    if (i == iMax && arr[i] < el) {
        return -1;
    }
    return i;
}

int main() {
    long long l, r;
    cin >> l >> r;

    size_t n;
    cin >> n;

    int dsr;
    long long sum = 0;

    vector<int> derev;
    for(size_t i = 0; i < n; i++) {
        int d;
        cin >> d;
        derev.push_back(d);
        sum += d;
    }

    vector<long long> distances;
    distances.push_back(0);
    for(size_t i = 0; i < n; i++) {
        distances.push_back(distances[i] + derev[i]);
    }

    long long start = 0;
    long long finish = l;

    size_t s_i = 0;
    size_t f_i = searchd(distances, finish);

    start = distances[s_i];
    finish = distances[f_i];

    if (f_i == -1) {
        cout << -1 << " " << -1;
        return 0;
    }
    if(distances[f_i] - distances[s_i] > r) {
        while(s_i < f_i && finish - start > r) {
            s_i++;
            start = distances[s_i];
            f_i = searchd(distances, l + start);
            if(f_i == -1) {
                cout << -1 << " " << -1;
                return 0;
            }
            finish = distances[f_i];
        }
        if(finish - start >= l && finish - start <= r) {
            cout << start << " " << finish;
            return 0;
        }
    }
    cout << start << " " << finish;

	return 0;
}
